#!/usr/bin/env python
#
# Copyright (c) 2016-2017, Parallels International GmbH
#
# This file is part of disp-helper. It's free software; you can redistribute
# it and/or modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the License,
# or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#
# Our contact details: Parallels International GmbH, Vordergasse 59, 8200
# Schaffhausen, Switzerland.
#

from rpmUtils.transaction import initReadOnlyTransaction
from infra_cep_helper import CEPCollecting


class Packages(CEPCollecting):
    def fill_results(self):
        specific_packages = {
            "openvswitch": "OpenVSwitch",
            "openstack-nova-compute": "Nova",
            "openstack-cinder": "Cinder",
            "openstack-neutron": "Neutron",
            "zabbix": "Zabbix",
            "nagios": "Nagios",
            "shaman ": "shaman",
            "cpupools-features": "cpupools",
            "pdrs ": "pdrs",
            "va-agent-core": "VA agent core",
            "bird": "BGP client",
            "extility-xvpagent": "FCO",
            "paci_hn_psbm": "PACI",
            "svmstack-nginx": "SolusVM"
        }
        ts = initReadOnlyTransaction()
        mi = ts.dbMatch()
        l = list()
        specific_soft = list()
        for h in mi:
            l.insert(0, "-".join([h["name"], h["version"], h["release"]]))
            if h["name"] in specific_packages:
                specific_soft.insert(0, specific_packages[h["name"]])
        self.result["Packages"] = "\n".join(l)
        self.result["SpecificSoftware"] = "\n".join(specific_soft)


def main():
    o = Packages()
    o.run()


if __name__ == "__main__":
    main()
